---
title: Create or update kinds
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Software Catalog
---

# Create or update kinds{% #create-or-update-kinds %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                           |
| ----------------- | ------------------------------------------------------ |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/catalog/kind |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/catalog/kind |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/catalog/kind      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/catalog/kind      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/catalog/kind  |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/catalog/kind     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/catalog/kind |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/catalog/kind |

### Overview

Create or update kinds in Software Catalog.

OAuth apps require the `apm_service_catalog_write` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#software-catalog) to access this endpoint.



### Request

#### Body Data (required)

Kind YAML or JSON.

{% tab title="Model" %}

| Parent field | Field                  | Type   | Description                                                                  |
| ------------ | ---------------------- | ------ | ---------------------------------------------------------------------------- |
|              | Option 1               | object | Schema for kind.                                                             |
| Option 1     | description            | string | Short description of the kind.                                               |
| Option 1     | displayName            | string | The display name of the kind. Automatically generated if not provided.       |
| Option 1     | kind [*required*] | string | The name of the kind to create or update. This must be in kebab-case format. |
|              | Option 2               | string | Kind definition in raw JSON or YAML representation.                          |

{% /tab %}

{% tab title="Example" %}

```json
{
  "description": "string",
  "displayName": "string",
  "kind": "my-job"
}
```

{% /tab %}

### Response

{% tab title="202" %}
ACCEPTED
{% tab title="Model" %}
Upsert kind response.

| Parent field | Field       | Type     | Description                                                                                                   |
| ------------ | ----------- | -------- | ------------------------------------------------------------------------------------------------------------- |
|              | data        | [object] | List of kind responses.                                                                                       |
| data         | attributes  | object   | Kind attributes.                                                                                              |
| attributes   | description | string   | Short description of the kind.                                                                                |
| attributes   | displayName | string   | User friendly name of the kind.                                                                               |
| attributes   | name        | string   | The kind name.                                                                                                |
| data         | id          | string   | A read-only globally unique identifier for the entity generated by Datadog. User supplied values are ignored. |
| data         | meta        | object   | Kind metadata.                                                                                                |
| meta         | createdAt   | string   | The creation time.                                                                                            |
| meta         | modifiedAt  | string   | The modification time.                                                                                        |
| data         | type        | string   | Kind.                                                                                                         |
|              | meta        | object   | Kind response metadata.                                                                                       |
| meta         | count       | int64    | Total kinds count.                                                                                            |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": [
    {
      "attributes": {
        "description": "string",
        "displayName": "string",
        "name": "my-job"
      },
      "id": "4b163705-23c0-4573-b2fb-f6cea2163fcb",
      "meta": {
        "createdAt": "string",
        "modifiedAt": "string"
      },
      "type": "string"
    }
  ],
  "meta": {
    "count": "integer"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/catalog/kind" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "kind": "my-job"
}
EOF 
                
##### 

```python
"""
Create or update kinds returns "ACCEPTED" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.software_catalog_api import SoftwareCatalogApi
from datadog_api_client.v2.model.kind_obj import KindObj

body = KindObj(
    kind="my-job",
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = SoftwareCatalogApi(api_client)
    response = api_instance.upsert_catalog_kind(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Create or update kinds returns "ACCEPTED" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::SoftwareCatalogAPI.new

body = DatadogAPIClient::V2::KindObj.new({
  kind: "my-job",
})
p api_instance.upsert_catalog_kind(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Create or update kinds returns "ACCEPTED" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.UpsertCatalogKindRequest{
		KindObj: &datadogV2.KindObj{
			Kind: "my-job",
		}}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewSoftwareCatalogApi(apiClient)
	resp, r, err := api.UpsertCatalogKind(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `SoftwareCatalogApi.UpsertCatalogKind`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `SoftwareCatalogApi.UpsertCatalogKind`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Create or update kinds returns "ACCEPTED" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.SoftwareCatalogApi;
import com.datadog.api.client.v2.model.KindObj;
import com.datadog.api.client.v2.model.UpsertCatalogKindRequest;
import com.datadog.api.client.v2.model.UpsertCatalogKindResponse;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    SoftwareCatalogApi apiInstance = new SoftwareCatalogApi(defaultClient);

    UpsertCatalogKindRequest body = new UpsertCatalogKindRequest(new KindObj().kind("my-job"));

    try {
      UpsertCatalogKindResponse result = apiInstance.upsertCatalogKind(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling SoftwareCatalogApi#upsertCatalogKind");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Create or update kinds returns "ACCEPTED" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_software_catalog::SoftwareCatalogAPI;
use datadog_api_client::datadogV2::model::KindObj;
use datadog_api_client::datadogV2::model::UpsertCatalogKindRequest;

#[tokio::main]
async fn main() {
    let body = UpsertCatalogKindRequest::KindObj(Box::new(KindObj::new("my-job".to_string())));
    let configuration = datadog::Configuration::new();
    let api = SoftwareCatalogAPI::with_config(configuration);
    let resp = api.upsert_catalog_kind(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Create or update kinds returns "ACCEPTED" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.SoftwareCatalogApi(configuration);

const params: v2.SoftwareCatalogApiUpsertCatalogKindRequest = {
  body: {
    kind: "my-job",
  },
};

apiInstance
  .upsertCatalogKind(params)
  .then((data: v2.UpsertCatalogKindResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
